// Climblife Mobile App

var STRIPE_API_PUBLISHABLE_KEY  = "pk_live_M3d9YWcmSJgzC0YZUuAwLOox";
// var STRIPE_API_PUBLISHABLE_KEY  = "pk_test_GTz7nGnC4jrZN4jW7FoJo6F6";
var TEST_MODE = false;
var db = null;

angular.module('climblife', ['ionic', 'climblife.controllers', 'climblife.services',
  'ngResource', 'ngCordova', 'ionic-timepicker', "stripe.checkout"])

.config(function($ionicConfigProvider) {
  $ionicConfigProvider.navBar.alignTitle('center');
})

.run(function($ionicPlatform, $rootScope, $log, $ionicPopup, $state, UserService) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }

    // UNCOMMENT BEFORE LAUNCH
    if (device.platform == 'iOS') {
      try {
        // Tag Manager
        var tagManager = cordova.require('com.jareddickson.cordova.tag-manager.TagManager');
        var trackingId = 'GTM-T29JMGZ';
        var intervalPeriod = 30; // seconds

        // Initialize Tag Manager
        tagManager.init(null, null, trackingId, intervalPeriod);
      } catch (error) {
      }
    }

    // UNCOMMENT BEFORE LAUNCH
    universalLinks.subscribe(null, function (eventData) {
      // do some work
      console.log('Did launch application from the link: ' + eventData.url);
    });
    universalLinks.subscribe('signup', function (eventData) {
      // do some work
      console.log('Did launch application from the link: ' + eventData.url);
      var url = new URL(eventData.url);
      var activationToken = url.pathname.split('/')[2];
      var email = url.searchParams.get("email");

      UserService.activate(activationToken, email, function(error, response) {
        console.log(error);
        console.log(response);

        if (error || response.error) {
          console.log(error || response.error);
          error = error || response.error;

          $rootScope.message = error;
          var alertPopup = $ionicPopup.alert({
            title: 'Error',
            templateUrl: 'templates/modals/success_or_error.html',
            scope: $rootScope
          });
          return;
        }
        localStorage.setItem('user_id', response.id);
        localStorage.setItem('authToken', response.auth_token);

        UserService.getMe(function(error, response) {
          console.log(error, response);
          if (error) return;

          $rootScope.registerDeviceToken();
          $state.go('app.landing');
        });
      })
    });
  });

  $rootScope.$on('$stateChangeStart', function (event, toState, toParams, fromState, fromParams) {
      $log.debug('$stateChangeStart to ' + toState.to + '- fired when the transition begins. toState,toParams : \n', toState, toParams);
  });
  $rootScope.$on('$stateChangeError', function (event, toState, toParams, fromState, fromParams, error) {
      $log.debug('$stateChangeError - fired when an error occurs during transition.');
      $log.debug(arguments);
  });
  $rootScope.$on('$stateChangeSuccess', function (event, toState, toParams, fromState, fromParams) {
      $log.debug('$stateChangeSuccess to ' + toState.name + '- fired once the state transition is complete.');
      console.log(event);
      console.log(toState);
      var event = {
        event: 'virtualpageview',
        pageUrl: toState.url,
        pageName: toState.name,
      };

      try {
        var result = dataLayer.push(event);
        console.log(result);
      } catch (error) {
        console.log(error);
      }
  });
  $rootScope.$on('$viewContentLoading',function(event, viewConfig){
    // runs on individual scopes, so putting it in "run" doesn't work.
    $log.debug('$viewContentLoading - view begins loading - dom not rendered',viewConfig);
  });
  $rootScope.$on('$viewContentLoaded', function (event) {
      $log.debug('$viewContentLoaded - fired after dom rendered', event);
  });
  $rootScope.$on('$stateNotFound', function (event, unfoundState, fromState, fromParams) {
      $log.debug('$stateNotFound ' + unfoundState.to + '  - fired when a state cannot be found by its name.');
      $log.debug(unfoundState, fromState, fromParams);
  });

  // UNCOMMENT BEFORE LAUNCH
  $rootScope.registerDeviceToken = function() {
    UserService.getMe(function(error, response) {
      console.log(error, response);
      if (error) return;

      console.log('Alert');
      UserService.registerDeviceToken(function(error, response) {
        console.log(error, response);
      });
      UserService.onNotification(function(error, response) {
        // console.log(error, response);

        var notification = response.aps ? response.aps.alert : response;

        if (!notification.title) return;

        console.log('Show push');
        var title = notification.title;
        $rootScope.message = notification.body;
        var alertPopup = $ionicPopup.alert({
          title: title,
          templateUrl: 'templates/modals/success_or_error.html',
          scope: $rootScope
        });
      });
    });
  };
  $rootScope.registerDeviceToken();
})

.config(['$httpProvider', function ($httpProvider) {
  $httpProvider.interceptors.push('errorInterceptor');
}])

.config(function($stateProvider, $urlRouterProvider, StripeCheckoutProvider) {

  StripeCheckoutProvider.defaults({key: STRIPE_API_PUBLISHABLE_KEY});

  $stateProvider

  // start of main app (not logged in) state
  .state('main', {
    url: "/main",
    abstract: true,
    templateUrl: "templates/default.html",
    controller: 'AppCtrl',
  })

  // start of main app (tabs) state
  .state('app', {
    url: "/app",
    abstract: true,
    templateUrl: "templates/menu.html",
    controller: 'AppCtrl',
  })

  .state('main.login', {
    url: '/login',
    views: {
      'tab-home': {
        templateUrl: 'templates/sessions/login.html',
        controller: 'SessionsNewCtrl'
      }
    }
  })
  .state('main.signup', {
    url: '/signup',
    views: {
      'tab-home': {
        templateUrl: "templates/users/new.html",
        controller: 'UsersNewCtrl'
      }
    }
  })
  .state('main.index', {
    url: "/index",
    views: {
      'tab-home': {
        templateUrl: "templates/landing.html",
        controller: "HomeCtrl"
      }
    }
  })
  .state('main.search', {
    url: "/search",
    views: {
      'tab-home': {
        templateUrl: "templates/home.html",
        controller: "HomeCtrl"
      }
    }
  })
  .state('main.feed', {
    url: "/trips/:startDate/:endDate/:type/:range",
    views: {
      'tab-home': {
        templateUrl: "templates/trips/index.html",
        controller: 'TripsCtrl'
      }
    }
  })
  .state('main.feedMap', {
    url: "/tripsMap/:startDate/:endDate/:type/:range",
    views: {
      'tab-home': {
        templateUrl: "templates/trips/map.html",
        controller: 'TripsMapCtrl'
      }
    }
  })
  .state('main.trip', {
    url: '/trips/:tripId',
    views: {
      'tab-home': {
        templateUrl: "templates/trips/show.html",
        controller: 'TripCtrl'
      }
    }
  })

  // .state('login', {
  //   url: '/login',
  //   templateUrl: 'templates/sessions/login.html',
  //   controller: 'SessionsNewCtrl'
  // })

  // // new user state
  // .state('signup', {
  //   url: '/signup',
  //   templateUrl: "templates/users/new.html",
  //   controller: 'UsersNewCtrl'
  // })

  // root/home page
  .state('app.landing', {
    url: "/landing",
    views: {
      'tab-home': {
        templateUrl: "templates/landing.html",
        controller: "HomeCtrl"
      }
    }
  })
  .state('app.home', {
    url: "/home",
    views: {
      'tab-home': {
        templateUrl: "templates/home.html",
        controller: "HomeCtrl"
      }
    }
  })

  .state('app.climblifeRules', {
    url: "/rules",
    views: {
      'tab-home': {
        templateUrl: "templates/rules.html",
        controller: "RulesCtrl"
      }
    }
  })

  // trips
  .state('app.feed', {
    url: "/trips/:startDate/:endDate/:type/:range",
    views: {
      'tab-home': {
        templateUrl: "templates/trips/index.html",
        controller: 'TripsCtrl'
      }
    }
  })
  .state('app.feedMap', {
    url: "/tripsMap/:startDate/:endDate/:type/:range",
    views: {
      'tab-home': {
        templateUrl: "templates/trips/map.html",
        controller: 'TripsMapCtrl'
      }
    }
  })

  .state('app.trip', {
    url: '/trips/:tripId',
    views: {
      'tab-home': {
        templateUrl: "templates/trips/show.html",
        controller: 'TripCtrl'
      }
    }
  })

  .state('app.tripConfirmation', {
    url: '/trips/:tripId/tripConfirmation',
    views: {
      'tab-home': {
        templateUrl: "templates/trips/trip_confirmation.html",
        controller: 'TripConfirmationCtrl',
        resolve: {
          // checkout.js isn't fetched until this is resolved.
          stripe: StripeCheckoutProvider.load
        }
      }
    }
  })
  // end trips

  // second tab
  .state('app.userTrips', {
    url: '/profile/trips',
    views: {
      'tab-trips': {
        templateUrl: 'templates/users/user_profile/trips.html',
        controller: "UserTripsCtrl"
      }
    }
  })

  .state('app.userTripDestroy', {
    url: '/profile/:tripId/tripDestroy',
    views: {
      'tab-trips': {
        templateUrl: 'templates/users/user_profile/delete_trip.html',
        controller: "UserTripDestroyCtrl"
      }
    }
  })

  .state('app.userTripConfirmationDestroy', {
    url: '/profile/:tripConfirmationId/tripConfirmationDestroy',
    views: {
      'tab-trips': {
        templateUrl: 'templates/users/user_profile/delete_trip_confirmation.html',
        controller: "UserTripConfirmationDestroyCtrl"
      }
    }
  })
  // end second tab

  // instant climb tab
  .state('app.instantClimbs', {
    url: "/instantClimbs",
    views: {
      'tab-instantClimbs': {
        templateUrl: 'templates/instant_climbs/index.html',
        controller: 'InstantClimbsCtrl'
      }
    }
  })

  .state('app.instantClimbsShow', {
    url: "/instantClimbs/:instantClimbId",
    views: {
      'tab-instantClimbs': {
        templateUrl: 'templates/instant_climbs/show.html',
        controller: 'InstantClimbsShowCtrl'
      }
    }
  })

  .state('app.instantClimbsCreate', {
    url: "/instantClimbs/create",
    views: {
      'tab-instantClimbs': {
        templateUrl: 'templates/instant_climbs/new.html',
        controller: 'InstantClimbsCreateCtrl'
      }
    }
  })

  .state('app.instantClimbConfirmation', {
    url: '/instantClimbs/:instantClimbId/confirmation/:bidId',
    views: {
      'tab-instantClimbs': {
        templateUrl: "templates/instant_climbs/confirmation.html",
        controller: 'InstantClimbConfirmationCtrl',
        resolve: {
          // checkout.js isn't fetched until this is resolved.
          stripe: StripeCheckoutProvider.load
        }
      }
    }
  })

  // (host tab)
  .state('app.userHostOptions', {
    url: '/profile/host_options',
    views: {
      'tab-hostOptions': {
        templateUrl: 'templates/users/user_profile/host_options.html',
        controller: "UserHostOptionsCtrl"
      }
    }
  })
  .state('app.userEditTrip', {
    url: '/profile/host_options/:tripId',
    views: {
      'tab-hostOptions': {
        templateUrl: 'templates/users/user_profile/host_options.html',
        controller: "UserHostOptionsCtrl"
      }
    }
  })

  // user settings page (will lead to rest of user edit options)
  .state('app.userProfile', {
    url: '/profile',
    views: {
      'tab-home': {
        templateUrl: "templates/users/profile.html",
        controller: "HomeCtrl"
      }
    }
  })

    /* all user edit (messages goes to section) */
    .state('app.userAbout', {
      url: '/profile/about',
      views: {
        'tab-home': {
          templateUrl: 'templates/users/user_profile/about.html',
          controller: "UserAboutCtrl"
        }
      }
    })

    .state('app.userReviews', {
      url: '/profile/reviews',
      views: {
        'tab-home': {
          templateUrl: 'templates/users/user_profile/reviews.html',
          controller: "UserReviewsCtrl"
        }
      }
    })

    .state('app.userVerify', {
      url: 'profile/user_verify',
      views: {
        'tab-home': {
          templateUrl: 'templates/users/user_profile/verification.html',
          controller: "UserVerificationCtrl"
        }
      }
    })

    .state('app.userPhotos', {
      url: 'profile/photos',
      views: {
        'tab-home': {
          templateUrl: 'templates/users/user_profile/photos.html',
          controller: "UserPhotosCtrl"
        }
      }
    })

    .state('app.userOrders', {
      url: 'profile/orders',
      views: {
        'tab-home': {
          templateUrl: 'templates/users/user_profile/orders.html',
          controller: "UserOrdersCtrl"
        }
      }
    })

  // users
  .state('app.users', {
    url: '/users',
    views: {
      'tab-home': {
        templateUrl: "templates/users/index.html",
        controller: 'UsersIndexCtrl'
      }
    }
  })

  .state('app.userShow', {
    url: "/users/:userId",
    views: {
      'tab-home': {
        templateUrl: "templates/users/show.html",
        controller: 'UsersShowCtrl'
      }
    }
  })

  .state('app.invite', {
    url: '/invite',
    views: {
      'tab-home': {
        templateUrl: 'templates/users/invite.html',
        controller: "InviteCtrl"
      }
    }
  })

  .state('app.messages', {
    url: "/messages",
    views: {
      'tab-messages': {
        templateUrl: "templates/messages/index.html",
        controller: 'MessagesCtrl'
      }
    }
  })

  .state('app.message', {
    url: "/messages/:messageId",
    views: {
      'tab-messages': {
        templateUrl: "templates/messages/show.html",
        controller: 'MessageCtrl'
      }
    }
  })

  // shop section
  .state('app.shop', {
    url: '/shop',
    views: {
      'tab-shop': {
        templateUrl: "templates/shop/index.html",
        controller: 'ShopIndexCtrl'
      }
    }
  })

  .state('app.product', {
    url: '/shop/:productId',
    views: {
      'tab-shop': {
        templateUrl: 'templates/shop/show.html',
        controller: 'ShopShowCtrl'
      }
    }
  })

    .state('app.amga', {
      url: '/profile/amga',
      views: {
        'tab-home': {
          templateUrl: 'templates/users/user_profile/amga.html',
          controller: "AmgaCtrl"
        }
      }
    })
  ;
  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/main/index');
})
