angular.module('climblife.controllers', [])

.controller('SessionsNewCtrl', function($scope, $rootScope, $state, $ionicPopup, LoginService, UserService, IpAddressService) {

  $scope.loginUser = function(email, password) {
    $scope.freezeButton = true;
    IpAddressService.getIpAddress(function(data_ip) {
      IpAddressService.getLocationFromIp(data_ip.ip, function(location) {
        var final_location = location.city + ', ' + location.region_code;
        LoginService.loginUser(email, password, final_location, function(data) {

          if (data.status && data.status == 404) {
            $scope.message = data.errors;
            var alertPopup = $ionicPopup.alert({
              title: 'Login Error',
              templateUrl: 'templates/modals/success_or_error.html',
              scope: $scope
            });
            $scope.freezeButton = undefined;
            return false;
          }

          if (data.auth_token && data.id) {
            document.getElementById('log-em').value = '';
            document.getElementById('log-pass').value = '';

            localStorage.setItem('user_id', data['id']);
            localStorage.setItem('authToken', data['auth_token']);

            // UNCOMMENT BEFORE LAUNCH
            $rootScope.registerDeviceToken();

            $state.go('app.landing');
            $scope.freezeButton = undefined;
          } else {
            // WILL IT EVER GO IN HERE????
            $scope.message = 'Must have valid email & password';
            var alertPopup = $ionicPopup.alert({
              title: 'Login Error',
              templateUrl: 'templates/modals/success_or_error.html',
              scope: $scope
            });
            $scope.freezeButton = undefined;
            return false;
          }
        })
      })
    })
  }

  // not using, but this is cordova sqlite syntax
  function insert (user_id, token) {
    var query = "INSERT INTO climblife (user_id, token) VALUES (?, ?)";
    $cordovaSQLite.execute(db, query, [user_id, token]).then(function(res) {
      alert("INSERT ID -> " + res.insertId);
    }, function (err) {
      alert(err);
    });
  }

  $scope.checkUser = function() {
    var token = window.localStorage.getItem('authToken');
    if (!token || token === undefined || token === "undefined" || token === null || token === "null") {
      // $state.go('main.login');
    } else {
      $state.go('app.landing');
    }
  }
})

.controller('UsersNewCtrl', function($scope, $ionicModal, $ionicPopup, $ionicHistory, UserNewService,
  $state, IpAddressService) {

  $scope.signUpUser = function(firstName, lastName, email, password, passwordConfirmation, age, waiver_signature, tos) {
    $scope.freezeButton = true;
    IpAddressService.getIpAddress(function(data_ip) {
      IpAddressService.getLocationFromIp(data_ip.ip, function(_location) {
        var final_location = _location.city + ', ' + _location.region_code;
        UserNewService.signupUser(firstName, lastName, email, password, passwordConfirmation, age,
          waiver_signature, tos, final_location, function(data){

            if (data.data.status === 422 ) {
              $scope.message = data.data.errors.join("");

              var alertPopup = $ionicPopup.alert({
                title: 'Verify',
                templateUrl: 'templates/modals/success_or_error.html',
                scope: $scope
              });

              alertPopup.then(function(res) {
                $scope.freezeButton = undefined;
                $state.go($state.current, {}, {reload: false});
              });
            } else {
              $scope.message = data.data.join("");

              var alertPopup = $ionicPopup.alert({
                title: 'Verify',
                templateUrl: 'templates/modals/success_or_error.html',
                scope: $scope
              });

              alertPopup.then(function(res) {
                $scope.freezeButton = undefined;
                $state.go('main.login');
              });
            }
        })
      })
    })    
  }

  $scope.myGoBack = function() {
    $ionicHistory.goBack();
  };

  // waiver modal
  $ionicModal.fromTemplateUrl('templates/modals/waiver_modal.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modal = modal;
  });

  $scope.viewWaiver = function() {
    $scope.modal.show();
  };

  $scope.closeModal = function() {
    $scope.modal.hide();
  };

  $scope.$on('$destroy', function() {
    $scope.modal.remove();
  });
})

.controller('AppCtrl', function($scope, $location, $ionicModal, $timeout, $state, UserService) {

  $scope._userId = window.localStorage['user_id'];

  $scope.goToProfile = function() {
    $state.go('app.userProfile');
  }

  $scope.goToPhotos = function() {
    $state.go('app.userPhotos');
  }

  $scope.goToUserProfile = function(id) {
    $state.go('app.userShow', {'userId': id});
  }

  $scope.goToAbout = function() {
    $state.go('app.userAbout');
  }

  $scope.goToReviews = function() {
    $state.go('app.userReviews');
  }

  $scope.goToTrips = function() {
    $state.go('app.userTrips');
  }

  $scope.goToHostOptions = function() {
    $state.go('app.userHostOptions');
  }

  $scope.goToRules = function() {
    $state.go('app.climblifeRules');
  }

  $scope.goToLink = function(stateName) {
    $state.go(stateName);
  }

  $scope.goToInvite = function() {
    $state.go('app.invite');
  }

  $scope.goToAmga = function() {
    $state.go('app.amga');
  }


  $scope.goToProfile = function() {
    $scope._userId = window.localStorage['user_id'];
    $state.go('app.userShow', {userId: $scope._userId});
  }

  $scope.goToHome = function() {
    $scope._userId = window.localStorage['user_id'];
    $state.go($scope._userId ? 'app.landing' : 'main.index', {reload: true}, {reload: true});
  }

  $scope.userLogOut = function() {
    // UNCOMMENT BEFORE LAUNCH
    UserService.removeDeviceToken(function() {});
    localStorage.removeItem('user_id');
    localStorage.removeItem('authToken');
    $state.go('main.login', {}, {reload: true});
  }

  $scope.goToLogin = function() {
    $state.go('main.login');
  }
})

.controller('RulesCtrl', function() {
  // this controller displays the rules in the sidebar
})

.controller('HomeCtrl', function($scope, $stateParams, $ionicSlideBoxDelegate, $state, $ionicPopup, MiscService) {

  $scope.range = '-1';

  MiscService.getHomeImages(function(data) {
    console.log(data);
    $scope.images = data;
  });

  setTimeout(function() {
    $ionicSlideBoxDelegate.slide(0);
    $ionicSlideBoxDelegate.update();
    $scope.$apply();
  });

  $scope.checkUser = function() {
    var token = window.localStorage.getItem('authToken');
    if (!token || token === undefined || token === "undefined" || token === null || token === "null") {
      // $state.go('main.login');
    } else {
      $state.go('app.landing');
    }
  }
  if ($state.current.name == 'main.index') {
    $scope.checkUser();
  }

  $scope.goToFeed = function(startDate, endDate, type, range) {
    $state.go($scope._userId ? 'app.feed' : 'main.feed', {
      startDate: startDate,
      endDate: endDate,
      type: type,
      range: range
    });
  }
  $scope.goToSearch = function() {
    $state.go($scope._userId ? 'app.search' : 'main.search');
  }
})

/* controller list for user profile section */
.controller('UserAboutCtrl', function($scope, $ionicPopup, $state, $ionicLoading, UserProfileService) {

  $scope.loading = $ionicLoading.show({
    content: 'Loading...',
    showBackdrop: false
  });

  UserProfileService.getAbout(function(error, data) {
    if (error) {
      $scope.message = 'Cannot get user info';
      var alertPopup = $ionicPopup.alert({
        title: 'User Profile',
        templateUrl: 'templates/modals/success_or_error.html',
        scope: $scope
      });

      alertPopup.then(function(res) {
        $state.go('app.landing');
        $scope.freezeButton = undefined;
      });
      return;
    }
    $scope.user = data;
    $ionicLoading.hide();
  })

  $scope.updateAbout = function(firstName, lastName, paypalEmail, currentLocation, experienceLevel, climbingType, age, description) {
    $scope.freezeButton = true;
    UserProfileService.postAbout(firstName, lastName, paypalEmail, currentLocation, experienceLevel, climbingType, age, description, function(data) {
      $scope.message = data.join("");

      var alertPopup = $ionicPopup.alert({
        title: 'User Profile',
        templateUrl: 'templates/modals/success_or_error.html',
        scope: $scope
      });

      alertPopup.then(function(res) {
        $state.go('app.landing');
        $scope.freezeButton = undefined;
      });
    })
  }

  $scope._userId = window.localStorage['user_id'];
})

.controller('UserReviewsCtrl', function($scope, $state, UserReviewService) {
  UserReviewService.getReviews(function(data) {
    $scope.reviewsForUser = data[0];
    $scope.reviewsByUser = data[1];
  })

  $scope.getNumber = function(num) {
    return new Array(num);
  }
})

.controller('UserTripsCtrl', function($scope, $stateParams, $ionicPopup, $state, $ionicLoading, TripService, InstantClimbService, InstantClimbBidService) {

  $scope.loading = $ionicLoading.show({
    content: 'Loading...',
    showBackdrop: false
  });

  TripService.allUserTrips(function(data) {
    $scope.hostTrips = data[0];
    $scope.climbingTrips = data[1];
    $ionicLoading.hide();
  });

  InstantClimbService.getAllForUser(function(data) {
    $scope.userInstantClimbs = data[0];
    $scope.bookedInstantClimbs = data[1];
  });

  $scope.doRefresh = function() {
    TripService.allUserTrips(function(data) {
      $scope.hostTrips = data[0];
      $scope.climbingTrips = data[1];
    });

    InstantClimbService.getAllForUser(function(data) {
      $scope.userInstantClimbs = data[0];
      $scope.bookedInstantClimbs = data[1];
    });
    $scope.$broadcast('scroll.refreshComplete');
  };

  $scope.goToTrip = function(tripId) {
    $state.go($scope._userId ? 'app.trip' : 'main.trip', { tripId: tripId });
  };
  $scope.editTrip = function(tripId) {
    $state.go('app.userEditTrip' , { tripId: tripId });
  };

  $scope.goToDeleteTrip = function(tripId) {
    $state.go('app.userTripDestroy', { tripId: tripId });
  };

  $scope.goToDeleteTripConfirmation = function(tripConfirmationId) {
    $state.go('app.userTripConfirmationDestroy', { tripConfirmationId: tripConfirmationId });
  };

  $scope.goToInstantClimb = function(instantClimbId) {
    $state.go('app.instantClimbsShow', { instantClimbId: instantClimbId })
  }
  
  $scope.deleteInstantClimb = function(instantClimbId) {
    if (confirm('Are you sure you want to delete your Instant Climb?')) {
      InstantClimbService.destroy(instantClimbId, function(data) {
        $scope.message = data;

        var alertPopup = $ionicPopup.alert({
          title: 'User Profile',
          templateUrl: 'templates/modals/success_or_error.html',
          scope: $scope
        });

        alertPopup.then(function(res) {
          $scope.doRefresh();
        });
      })
    }
  }

  $scope.goToHost = function(userId) {
    $state.go('app.userShow', {'userId': userId});
  }

  $scope.viewBidder = function(userId) {
    $state.go('app.userShow', {'userId': userId});
  }

  $scope.goToPayment = function(instant_climb_id, bid_id) {
    $state.go('app.instantClimbConfirmation', {'instantClimbId': instant_climb_id, 'bidId': bid_id})
  }

  $scope.rejectBid = function(instant_climb_id, bid_id) {
    InstantClimbBidService.rejectBid(instant_climb_id, bid_id, function(data) {
      $scope.message = data.join('');
      var alertPopup = $ionicPopup.alert({
        title: 'Instant Climbs',
        templateUrl: 'templates/modals/success_or_error.html',
        scope: $scope
      });

      alertPopup.then(function(res) {
        $scope.doRefresh();
        $scope.freezeButton = false;
      });
    })
  }
})

.controller('UserTripDestroyCtrl', function($scope, $state, $ionicLoading, $ionicPopup, $stateParams, TripService) {
  // for deleting trips
  $scope.loading = $ionicLoading.show({
    content: 'Loading...',
    showBackdrop: false
  });

  TripService.getTripDestroy($stateParams.tripId, function(data) {
    $scope.trip = data;
    $ionicLoading.hide();
  })

  $scope.destroyTrip = function(trip_id) {
    // logic
    TripService.deleteTrip(trip_id, function(data) {
      $scope.message = data.join("");

      var alertPopup = $ionicPopup.alert({
        title: 'User Profile',
        templateUrl: 'templates/modals/success_or_error.html',
        scope: $scope
      });

      alertPopup.then(function(res) {
        // want this state to "reload" so it reflects that an
        // item has been deleted out of scope. could hard reload
        $state.go('app.userTrips', {reload: true});
      });
    })
  }

  $scope.goToUserTrips = function() {
    $state.go('app.userTrips');
  }
})

.controller('UserTripConfirmationDestroyCtrl', function($scope, $state, $stateParams, $ionicLoading,
 $ionicPopup, TripConfirmationService) {
  // for deleting trip confirmations i.e. climber trips
  $scope.loading = $ionicLoading.show({
    content: 'Loading...',
    showBackdrop: false
  });

  TripConfirmationService.getTrip($stateParams.tripConfirmationId, function(data) {
    $scope.trip_confirmation = data[0];
    $scope.trip = data[1];
    $ionicLoading.hide();
  });

  $scope.deleteTripConfirmation = function(trip_confirmation_id) {
    TripConfirmationService.deleteTrip(trip_confirmation_id, function(data) {
      $scope.message = data.join("");

      var alertPopup = $ionicPopup.alert({
        title: 'User Profile',
        templateUrl: 'templates/modals/success_or_error.html',
        scope: $scope
      });

      alertPopup.then(function(res) {
        $state.go('app.userTrips');
      });
    });
  }

  $scope.goToUserTrips = function() {
    $state.go('app.userTrips');
  }
})

// like on website this is section for "hosts" to make trips
// combing host options + verification into 1 controller + view
.controller('UserHostOptionsCtrl', function($scope, $state, $ionicLoading, $ionicPopup, ImageService, 
                                          TripService, UserPictureService, UserPhoneVerificationService, UserService,
                                          UserTripService, UserProfileService, ionicTimePicker, $stateParams, $ionicModal) {


  $scope.doGetImage = function () {
    ImageService.getImage(function(base64Img) {
      $scope.base64 = base64Img;
    }, function(error) {
      console.log(error);
    });
  }

  $scope.doRefresh = function() {
    $scope.loading = $ionicLoading.show({
      content: 'Loading...',
      showBackdrop: true
    });
    $scope.loading = $ionicLoading.show({
      content: 'Loading...',
      showBackdrop: true
    });
    UserProfileService.userHost(function(data) {
      if (!data || data.code == 401) {
        $ionicLoading.hide();

        localStorage.removeItem('user_id');
        localStorage.removeItem('authToken');
        $state.go('main.login', {}, {reload: true});
        return;
      }

      $scope.oldImages = [];

      $scope.climbing_types    = data[0].climbing_types;
      $scope.experience_levels = data[0].experience_levels;
      $scope.user_host         = data[0]['is_user_host?'];
      $scope.uploadedUhv       = data[0]['uploaded_uhv?'];
      $scope.signedi9          = data[0]['signed_i9?'];
      $scope.phoneNumVerified  = data[0].phone_number_verified;
      $scope.$broadcast('scroll.refreshComplete');

      if (tripId) {
        TripService.getTrip(tripId, function(result) {
          $ionicLoading.hide();

          if (!result || result.code == 401) {
            localStorage.removeItem('user_id');
            localStorage.removeItem('authToken');
            $state.go('main.login', {}, {reload: true});
            return;
          }

          var tripData = result[0];

          $scope._title = tripData.title;
          $scope.startDate = new Date(tripData.start_date);
          $scope.endDate = new Date(tripData.end_date);
          $scope.startTime = new Date('1970/01/01 '+tripData.start_time);
          $scope.endTime = new Date('1970/01/01 '+tripData.end_time);
          $scope.pickup_address = tripData.pickup_address;
          $scope.climbingSpot = tripData.climbing_spot;
          $scope.price = tripData.price;
          $scope.available_spots = tripData.available_spots;
          $scope.experience_level = tripData.experience_level;
          $scope.notes = tripData.notes;
          $scope.oldImages = result[2];
          $scope.climbing_type = [];

          var types = tripData.climbing_type.split(',');
          for (var i in types) {
            var type = types[i].trim();

            var index = $scope.climbing_types.indexOf(type);
            if (index >= 0) $scope.climbing_type.push(index);
          }

          $scope.climbing_type = $scope.climbing_type.join(',');
        });
      } else {
        $ionicLoading.hide();
      }
    });
  };

  var tripId = $scope.tripId = $stateParams.tripId;

  $scope.doRefresh();

  $scope.images = [];
  $scope.deleteImages = [];

  $scope.attachImage = function() {
    if ($scope.oldImages.length + $scope.images.length >= 3) {
      $scope.message = "Cannot attach more than three image";
      return $ionicPopup.alert({
        title: 'User Profile',
        templateUrl: 'templates/modals/success_or_error.html',
        scope: $scope
      });
    }

    function toDataUrl(url, callback) {
      var xhr = new XMLHttpRequest();
      xhr.onload = function() {
        var reader = new FileReader();
        reader.onloadend = function() {
          callback(reader.result);
        }
        reader.readAsArrayBuffer(xhr.response);
      };
      xhr.open('GET', url);
      xhr.responseType = 'blob';
      xhr.send();
    }
    ionic.Platform.ready(function(){
      navigator.camera.getPicture(function(file) {
        return toDataUrl(file, function(data) {
          $scope.images.push({
            file: file,
            data: new Blob([data])
          });
          $scope.$apply();
        })
      }, function(error) {
        $scope.message = "Error: Failed to Attach Image \n" + error ;

        var alertPopup = $ionicPopup.alert({
          title: 'User Profile',
          templateUrl: 'templates/modals/success_or_error.html',
          scope: $scope
        });
      }, {
        destinationType: Camera.DestinationType.FILE_URI,
        sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
        correctOrientation: true,
        maximumImagesCount: 1,
        targetWidth: 800,
        targetHeight: 800,
        quality: 20,
        outputType: 0
      });
    });
  }
  $scope.removeImage = function(index) {
    $scope.images.splice(index, 1);
  }
  $scope.removeOldImage = function($index, image) {
    if (!Array.isArray($scope.oldImages)) return;
    var index = -1;
    for (var i = 0; i < $scope.oldImages.length; i++) {
      if ($scope.oldImages[i].id == image.id) {
        index = i;
        break;
      }
    }
    if (index < 0) return;

    $scope.oldImages.splice(index, 1);
    $scope.deleteImages.push(image.id);
  }

  var oldStartDate;
  $scope.cloneDate = function(scope) {
    if (scope.endDate && scope.endDate != '' && scope.endDate > scope.startDate && scope.endDate != oldStartDate) return;
    scope.endDate = scope.startDate;
    oldStartDate = scope.startDate;
  };

  $scope.newTrip = function(title, startDate, endDate, startTime, endTime, pickup_address, climbingSpot, price, before_price, available_spots, languages_spoken, climbing_type, experience_level, notes) {
    $scope.freezeButton = true;
    $scope.loading = $ionicLoading.show({
      content: 'Loading...',
      showBackdrop: true
    });
    UserTripService.createTrip(tripId, title, startDate, endDate, startTime, endTime, pickup_address, climbingSpot, price, before_price, available_spots, languages_spoken, climbing_type, experience_level, notes, $scope.images, $scope.deleteImages, function(data) {
      $ionicLoading.hide();

      if (data.errors) {
        $scope.message = data.errors.join("");

        var alertPopup = $ionicPopup.alert({
          title: "Error",
          templateUrl: 'templates/modals/success_or_error.html',
          scope: $scope
        });

        alertPopup.then(function(res) {
          $scope.freezeButton = undefined;
          // this doesn't actually do anything
          $state.go($state.current, {}, {reload: true});
        });
      } else {
        $scope.message = data.join("");

        var alertPopup = $ionicPopup.alert({
          title: "",
          templateUrl: 'templates/modals/success_or_error.html',
          scope: $scope
        });

        alertPopup.then(function(res) {
          $scope.freezeButton = undefined;
          window.location.reload();
        });
      }
    })
  }

  // should disappear on completion
  $scope.getPhoneNumber = function(phoneNumber) {
    $scope.phoneSent = true;
    UserPhoneVerificationService.getVerificationCode(phoneNumber, function(data) {
      $scope.message = data.join("");

      var alertPopup = $ionicPopup.alert({
        title: 'User Profile',
        templateUrl: 'templates/modals/success_or_error.html',
        scope: $scope
      });
    });
    $scope.sent = true;
  }

  $scope.inputCode = function(code) {
    $scope.inputSent = true;
    UserPhoneVerificationService.verifyPhoneNumber(code, function(data) {
      $scope.message = data.join("");

      var alertPopup = $ionicPopup.alert({
        title: 'User Profile',
        templateUrl: 'templates/modals/success_or_error.html',
        scope: $scope
      });

      alertPopup.then(function() {
        $state.go($state.current, {}, {reload: true});
      })
    });
  }

  $scope.uploadPic = function(imgFile) {
    $scope.hideUpload = true;
    UserPictureService.uhv_upload(imgFile, function(data) {
      $scope.message = "Image Submitted. May take 24 hours or more for approval";
      var alertPopup = $ionicPopup.alert({
        title: 'User Photos',
        templateUrl: 'templates/modals/success_or_error.html',
        scope: $scope
      });

      alertPopup.then(function(res) {
        $scope.doRefresh();
      });
    })
  }

  $ionicModal.fromTemplateUrl('templates/modals/i9.html', {
    scope: $scope
  }).then(function(modal) {
    $scope.modal = modal;
  });

  $scope.signi9Form = function(name) {
    UserService.signi9Form(name, function(data) {
      $scope.message = data.join("");
      var alertPopup = $ionicPopup.alert({
        title: 'I9 Form',
        templateUrl: 'templates/modals/success_or_error.html',
        scope: $scope
      });

      alertPopup.then(function(res) {
        $scope.doRefresh();
      });
    })
  }

})

.controller('UserPhotosCtrl', function($scope, $state, $ionicPlatform, UserPictureService, ImageService, $ionicPopup, $ionicLoading) {

  UserPictureService.getAll(function(data) {
    $scope.user_images = data;
  });

  $scope.doGetImage = function () {
    ImageService.getImage(function(base64Img) {
      $scope.base64 = base64Img;
        $state.go($state.current, {}, {reload: false});
    }, function(error) {
      console.log(error);
    });
  }

  $scope.uploadPic = function(imgFile) {
    $scope.freezeButton = true;
    UserPictureService.upload(imgFile, function(data) {
      $scope.message = data.join("");
      var alertPopup = $ionicPopup.alert({
        title: 'User Photos',
        templateUrl: 'templates/modals/success_or_error.html',
        scope: $scope
      });

      alertPopup.then(function(res) {
        UserPictureService.getAll(function(data) {
          $scope.user_images = data;
          $scope.base64 = undefined;
          $scope.freezeButton = undefined;
        });
      });
    })
  }

  $scope.destroyPhoto = function(image_id) {
    UserPictureService.destroy(image_id, function(data) {
      $scope.message = data.join("");
      var alertPopup = $ionicPopup.alert({
        title: 'User Profile',
        templateUrl: 'templates/modals/success_or_error.html',
        scope: $scope
      });

      alertPopup.then(function(res) {
        UserPictureService.getAll(function(data) {
          $scope.user_images = data;
        });
      });
    })
  }
})
/* end user profile ctrl list */

.controller('UsersShowCtrl', function($scope, $state, $stateParams, $ionicLoading, $ionicModal,
  $ionicSlideBoxDelegate, UserService, UserTripService, $ionicHistory) {

  $scope.loading = $ionicLoading.show({
    content: 'Loading...',
    showBackdrop: false
  });

  UserService.getUser($stateParams.userId, function(data) {
    $scope.user = data;
    $scope.images = data.images;
    $scope.firstName = data.first_name;
    $scope.upcoming_trips = data.upcoming_trips;
    $ionicLoading.hide();
    $ionicSlideBoxDelegate.update();
  })

  $scope.doRefresh = function() {
    UserService.getUser($stateParams.userId, function(data) {
      $scope.user = data;
      $scope.images = data.images;
      $scope.firstName = data.first_name;
      $scope.upcoming_trips = data.upcoming_trips;
      $ionicLoading.hide();
      $ionicSlideBoxDelegate.update();
      $scope.$broadcast('scroll.refreshComplete');
    })
  }

  setTimeout(function() {
    $ionicSlideBoxDelegate.slide(0);
    $ionicSlideBoxDelegate.update();
    $scope.$apply();
  });

  $scope.getNumber = function(num) {
    return new Array(num);
  }

  $scope.goHome = function() {
    $state.go('app.landing');
    $ionicHistory.nextViewOptions({
      disableBack: true
    });
  }

  $ionicModal.fromTemplateUrl('templates/modals/upcoming_trips.html', {
    scope: $scope,
    animation: 'slide-in-up'
  }).then(function(modal) {
    $scope.modal = modal;
  });

  $scope.openModal = function(upcoming_trips) {
    $scope.upcoming_trips = upcoming_trips;
    $scope.image = $scope.images[0];
    $scope.firstName = $scope.firstName;
    $scope.modal.show();
  };

  $scope.closeModal = function() {
    $scope.modal.hide();
  };
  // have to close modal before you can go to different state
  $scope.goToTrip = function(tripId) {
    $scope.modal.hide();
    $state.go('app.trip', {tripId: tripId});
  };

  // Cleanup the modal when we're done with it
  $scope.$on('$destroy', function() {
    $scope.modal.remove();
  });
})
/* end users */


/* messages */
.controller('MessagesCtrl', function($scope, $ionicLoading, $ionicPopup, ConversationService) {

  $scope.loading = $ionicLoading.show({
    content: 'Loading...',
    showBackdrop: false
  });

  $scope.doRefresh = function() {
    ConversationService.index(function(data) {
      $scope.messages = data.conversations;
      $scope.$broadcast('scroll.refreshComplete');
    });
  }

  $scope.getAvatar = function(message) {
    var avatars = message.sender_pictures;
    return (avatars && Array.isArray(avatars) && avatars.length > 0) ? avatars[0] : null;
  }

  ConversationService.index(function(data) {
    $scope.messages = data.conversations;
    $ionicLoading.hide();
  });

  $scope.deleteConversation = function(messageId) {
    ConversationService.deleteConversation(messageId, function(data) {
      $scope.message = data.join("");
      var alertPopup = $ionicPopup.alert({
        title: 'Messages',
        templateUrl: 'templates/modals/success_or_error.html',
        scope: $scope
      });

      alertPopup.then(function(res) {
        ConversationService.index(function(data) {
          $scope.messages = data.conversations;
        });
      });
    });
  }
})

.controller('MessageCtrl', function($scope, $stateParams, $state, $ionicPopup, $ionicLoading, ConversationService) {
  $scope.loading = $ionicLoading.show({
    content: 'Loading...',
    showBackdrop: false
  });

  $scope.doRefresh = function() {
    ConversationService.show($stateParams.messageId, function(data) {
      $scope.conversations = data;
      $scope.$broadcast('scroll.refreshComplete');
    });
  }

  ConversationService.show($stateParams.messageId, function(data) {
    $scope.conversations = data;
    $ionicLoading.hide();
  });

  $scope.resetFormVal = function() {
    document.getElementById('mText').value = '';
  }

  $scope.sendMessage = function(message, conversationId) {
    $scope.freezeButton = true;
    if (message === undefined || message.length < 1) {
      $scope.message = 'Must enter text';
      var alertPopup = $ionicPopup.alert({
        title: 'Messages',
        templateUrl: 'templates/modals/success_or_error.html',
        scope: $scope
      });
    } else {
      ConversationService.reply(message, conversationId, function(data) {
        $scope.message = data.join("");

        var alertPopup = $ionicPopup.alert({
          title: 'Messages',
          templateUrl: 'templates/modals/success_or_error.html',
          scope: $scope
        });

        alertPopup.then(function(res) {
          ConversationService.show($stateParams.messageId, function(data) {
            $scope.conversations = data;
            $scope.resetFormVal();
            $scope.freezeButton = undefined;
          });
        });
      })
    }
  }
})
/* end messages */

/* trips */
.controller('TripsCtrl', function($scope, $stateParams, TripService, $ionicSlideBoxDelegate,
 $ionicLoading, $ionicPopup, $ionicHistory, $state) {

  // filter stuff, init here
  $scope.filter = {
    startDate: $stateParams.startDate,
    endDate: $stateParams.endDate,
    type: $stateParams.type,
    range: $stateParams.range,
  };

  $scope.getTrips = function() {
    $scope.loading = $ionicLoading.show({
      content: 'Loading...',
      showBackdrop: false
    });

    TripService.getTrips({
      from: $scope.filter.startDate,
      to: $scope.filter.endDate,
      type: $scope.filter.type,
      range: $scope.filter.range
    }, function(error, data) {
      console.log(error, data);
      $ionicLoading.hide();
      if (error) {
        console.log(error);
        alert(error.message);
        $ionicHistory.goBack();
        return;
      }
      if (!data) {
        alert('Cannot get data');
        $ionicHistory.goBack();
        return;
      }
      $scope.trips = data;
    });
  }
  $scope.getTrips();

  setTimeout(function() {
    $ionicSlideBoxDelegate.slide(0);
    $ionicSlideBoxDelegate.update();
    $scope.$apply();
  });

  $scope.goToTrip = function(tripId) {
    $state.go($scope._userId ? 'app.trip' : 'main.trip', {tripId: tripId});
  };

  $scope.getNumber = function(num) {
    return new Array(num);
  };

  $scope.changeFilter = function() {
    $scope.getTrips();
  }

  $scope.searchFeed = function(startDate, endDate) {
    if (startDate === undefined || endDate === undefined) {
     $scope.message = "Must have valid start date and end date";
     var alertPopup = $ionicPopup.alert({
       title: 'Trip Feed',
       templateUrl: 'templates/modals/success_or_error.html',
       scope: $scope
     });
     return false;
    } else {
      TripService.betweenDates(new Date($stateParams.startDate), new Date($stateParams.endDate), function(data) {
        $scope.trips = data;
      });
      return true;
    }
  };

  $scope.goToMap = function() {
    $state.go(
      $scope._userId ? 'app.feedMap' : 'main.feedMap',
      {
        startDate: $scope.filter.startDate,
        endDate: $scope.filter.endDate,
        type: $scope.filter.type,
        range: $scope.filter.range
      }
    );
  };

  $scope.goToInstantClimbs = function() {
    $state.go('app.instantClimbsCreate');
  }

  $scope.isUserSignedIn = window.localStorage['user_id'] ? true : false;

  $scope.showPopup = function() {
    $scope.data = {}

    // Custom popup
    var myPopup = $ionicPopup.show({
       title: 'Must Log In To Create Instant Climbs',
       scope: $scope,
    
      buttons: [
        { text: 'Ok', type: 'button-positive' }
      ]
    });

    myPopup.then(function(res) {
       console.log('Tapped!', res);
    });    
  };
})
.controller('TripsMapCtrl', function($scope, $stateParams, TripService, $ionicSlideBoxDelegate, $ionicLoading, $ionicPopup, $state) {

  $scope.loading = $ionicLoading.show({
    content: 'Loading...',
    showBackdrop: false
  });

  var showMap = function(trips, position) {
    $scope.trips = trips;
    if (position.lat != undefined && position.lng != undefined) $scope.center = position;
    $scope.markers = [];
    for (var i in trips) {
        var trip = trips[i];
        if (!trip.location) return;
        var lat = trip.location.latitude,
            lng = trip.location.longitude;
        trip.url = ($scope._userId ? '#/app' : '#/main') + '/trips/' + trip.id
        $scope.markers.push({
            id: trip.id,
            lat: lat,
            lng: lng,
            title:  trip.location.county_name,
            trip: trip,
            info: 'info-trip-'+trip.id,
            label: '$'+trip.price
        });
    }
  };

  TripService.getTrips({
    from: $stateParams.startDate,
    to: $stateParams.endDate,
    type: $stateParams.type,
    range: $stateParams.range,
    isMap: false
  }, function(error, data, position) {
    $ionicLoading.hide();
    console.log(data);
    if (!data) {
      alert('Cannot get data');
      $ionicHistory.goBack();
      return;
    }
    showMap(data, position);
  });

  setTimeout(function() {
    $ionicSlideBoxDelegate.slide(0);
    $ionicSlideBoxDelegate.update();
    $scope.$apply();
  });

  $scope.goToTrip = function(tripId) {
    $state.go($scope._userId ? 'app.trip' : 'main.trip', {tripId: tripId});
  };

  $scope.getNumber = function(num) {
    return new Array(num);
  };

  $scope.searchFeed = function(startDate, endDate) {
    if (startDate === undefined || endDate === undefined) {
     $scope.message = "Must have valid start date and end date";
     var alertPopup = $ionicPopup.alert({
       title: 'Trip Feed',
       templateUrl: 'templates/modals/success_or_error.html',
       scope: $scope
     });
     return false;
    } else {
      TripService.betweenDates(new Date($stateParams.startDate), new Date($stateParams.endDate), function(data) {
        $scope.trips = data;
      });
      return true;
    }
  };

  // filter stuff, init here
  $scope.filter = {
    from: $stateParams.startDate,
    to: $stateParams.endDate,
    type: $stateParams.type,
    range: $stateParams.range,
  };
})

.controller('TripCtrl', function($scope, $state, TripService, $ionicSlideBoxDelegate, $stateParams,
  UserService, $ionicLoading, $ionicModal, $ionicPopup, StripeCharge, TripConfirmationService) {

  $scope.loading = $ionicLoading.show({
    content: 'Loading...',
    showBackdrop: false
  });

  TripService.getTrip($stateParams.tripId, function(data) {
    $scope.trip = data[0];
    $scope.climber = data[1];
    // $scope.climber.amga = true;
    $scope.user_images = data[2];
    $scope.can_user_book = data[3];
    $ionicLoading.hide();
    $ionicSlideBoxDelegate.update();
  });

  $scope.viewHost = function(climber_id) {
    $state.go('app.userShow', {userId: climber_id});
  };

  $scope.goToPayment = function(tripId) {
    $state.go('app.tripConfirmation', {tripId: tripId});
  };

  $scope.isUserSignedIn = window.localStorage['user_id'] ? true : false;

  $scope.showPopup = function() {
    var myPopup = $ionicPopup.show({
       title: 'Must Log In To View Profile',
       scope: $scope,
    
      buttons: [
        { text: 'Ok', type: 'button-positive' }
      ]
    });

    myPopup.then(function(res) {
       console.log('Tapped!', res);
    });    
  };
})

.controller('TripConfirmationCtrl', function($scope, $state, TripService, $ionicSlideBoxDelegate, $stateParams,
  UserService, $ionicLoading, $ionicModal, $ionicPopup, StripeCharge, TripConfirmationService) {

  TripService.getTrip($stateParams.tripId, function(data) {
    $scope.trip = data[0];
    $scope.climber = data[1];
    $scope.user_images = data[2];
    $ionicLoading.hide();
    $ionicSlideBoxDelegate.update();
  });

  $scope.goBack = function() {
    $state.go('app.trip', {tripId: $scope.trip.id});
  }

  // payment stuff
  // init "ProductMeta" as empty obj
  $scope.ProductMeta = {};

  $scope.charge = function() {
    // "ProductMeta" built w/ trip as $scope.trip instead of charge(trip)
    $scope.ProductMeta.title = $scope.trip.title;
    $scope.ProductMeta.description = $scope.trip.notes;
    $scope.ProductMeta.priceUSD = $scope.trip.price;
    $scope.ProductMeta.image = $scope.user_images[0];

    StripeCharge.getStripeToken($scope.ProductMeta).then(
      function(data){
        proceedCharge(data);
      },
      function(error){
        console.log(error);
      }
    );

    function proceedCharge(data) {
      // StripeCharge.chargeUser(stripeToken, $scope.ProductMeta).then(
      //   function (StripeInvoiceData) {
          // run script to update trip, make trip_conf, etc here
          // on success of those service calls, then render this popup
          return TripConfirmationService.bookTrip($scope.trip.id, data.stripeToken, data.stripeEmail, function(data) {
            $scope.message = data.join("");
            var alertPopup = $ionicPopup.alert({
              title: 'Trip Feed',
              templateUrl: 'templates/modals/success_or_error.html',
              scope: $scope
            });

            alertPopup.then(function(res) {
              $state.go('app.userTrips');
            });
          })
        // },
        // function (error) {
        //   $scope.message = "Oops... something went wrong: \n" + error;
        //   var alertPopup = $ionicPopup.alert({
        //     title: 'Trip Feed',
        //     templateUrl: 'templates/modals/success_or_error.html',
        //     scope: $scope
        //   });

        //   alertPopup.then(function(res) {
        //     $state.go($state.current, {}, {reload: true});
        //   });
        // }
      // );
    };
  };
})

.controller('AmgaCtrl', function($scope, $state, $ionicPlatform, AmgaService, ImageService, $ionicPopup, $ionicLoading) {

  function getCertification() {
    AmgaService.get(function(data) {
      // $scope.user_images = data;
      console.log(data);
      $scope.amga = data.image ? data : null;
    });
  }

  $scope.doGetImage = function () {
    ImageService.getImage(function(base64Img) {
      $scope.base64 = base64Img;
    }, function(error) {
      console.log(error);
    });
  }

  $scope.uploadPic = function(imgFile) {
    $scope.freezeButton = true;

    $scope.loading = $ionicLoading.show({
      content: 'Uploading...',
      showBackdrop: false
    });
    AmgaService.upload(imgFile, function(data) {
      $ionicLoading.hide();
      $scope.message = "Upload success";
      var alertPopup = $ionicPopup.alert({
        title: 'User Photos',
        templateUrl: 'templates/modals/success_or_error.html',
        scope: $scope
      });

      alertPopup.then(function(res) {
        $scope.base64 = false;
        getCertification();
        $scope.freezeButton = false;
      });
    })
  }

  $scope.destroyPhoto = function(image_id) {
    AmgaService.destroy(image_id, function(data) {
      $scope.message = data.join("");
      var alertPopup = $ionicPopup.alert({
        title: 'User Profile',
        templateUrl: 'templates/modals/success_or_error.html',
        scope: $scope
      });

      alertPopup.then(function(res) {
        getCertification();
        $scope.freezeButton = false;
      });
    })
  }
  getCertification();
})
.controller('InviteCtrl', function($scope, $state, $ionicPopup, $ionicLoading, UserService) {
  var id = 1;
  $scope.emails = [{
    id: 1,
    email: ''
  }];

  $scope.addEmail = function() {
    id++;
    $scope.emails.push({id: id, email: ''});
  }

  $scope.remove = function(index) {
    $scope.emails.splice(index, 1);
  }

  $scope.submit = function(emails, reinvite) {
    emails = emails || ($scope.emails.map(function(email) {return email.email}));

    $scope.loading = $ionicLoading.show({
      content: 'Uploading...',
      showBackdrop: false
    });

    UserService.invite(emails, reinvite, function(error, response) {
      console.log(error, response);
      $ionicLoading.hide();

      if (response.status && response.data && response.data.old_invited && Array.isArray(response.data.old_invited) && response.data.old_invited.length > 0) {
        $scope.message = 'These emails ('+ (response.data.old_invited.join(',')) + ') is already invited. Do you want to resend invitation?';
        var alertPopup = $ionicPopup.prompt({
          title: 'Invite Friend',
          templateUrl: 'templates/modals/success_or_error.html',
          scope: $scope
        });

        alertPopup.then(function(response) {
          if (response === undefined) return;

          $scope.submit(emails, true);
        });
      } else if (response.status) {
        $scope.message = 'Thank you for inviting your friend';
        var alertPopup = $ionicPopup.alert({
          title: 'Invite Friend',
          templateUrl: 'templates/modals/success_or_error.html',
          scope: $scope
        });

        alertPopup.then(function(res) {
          $scope.emails = [{
            id: 1,
            email: ''
          }];
        });
      } else {
        $scope.message = response.message;
        var alertPopup = $ionicPopup.alert({
          title: 'Invite Friend',
          templateUrl: 'templates/modals/success_or_error.html',
          scope: $scope
        });

        alertPopup.then(function(res) {
        });
      }
    })
  }
})
/* end trips stuff */

.controller('InstantClimbsCtrl', function($scope, $state, $ionicPopup, $ionicLoading, InstantClimbService, InstantClimbBidService) {

  $scope.loading = $ionicLoading.show({
    content: 'Loading...',
    showBackdrop: false
  });

  InstantClimbService.getAll(function(data) {
    $scope.instantClimbs = data[0];
    $ionicLoading.hide();
  })

  $scope.doRefresh = function() {
    InstantClimbService.getAll(function(data) {
      $scope.instantClimbs = data[0];
      $scope.$broadcast('scroll.refreshComplete');
    })
  };

  $scope.goToCreate = function() {
    $state.go('app.instantClimbsCreate')
  }

  $scope.goToInstantClimb = function(instantClimbId) {
    $state.go('app.instantClimbsShow', { instantClimbId: instantClimbId })
  }

  $scope.goToHost = function(userId) {
    $state.go('app.userShow', {'userId': userId});
  }
})

.controller('InstantClimbsShowCtrl', function($scope, $state, $stateParams, $ionicPopup, $ionicLoading, InstantClimbService, InstantClimbBidService) {
  $scope.loading = $ionicLoading.show({
    content: 'Loading...',
    showBackdrop: false
  });

  $scope.viewHost = function(userId) {
    $state.go('app.userShow', {'userId': userId});
  }

  InstantClimbService.show($stateParams.instantClimbId, function(data) {
    $scope.instantClimb = data;
    $scope.bids_count = data.bids_count;
    $scope.isUser = window.localStorage['user_id'] == data.user_id ;
    $ionicLoading.hide();
  });

  $scope.newInstantClimbBid = function(price, notes) {
    $scope.freezeButton = true;
    $scope.loading = $ionicLoading.show({
      content: 'Loading...',
      showBackdrop: true
    });
    InstantClimbBidService.create($stateParams.instantClimbId, price, notes, function(data) {
      $ionicLoading.hide();

      if (data.errors) {
        $scope.message = data.errors;

        var alertPopup = $ionicPopup.alert({
          title: "Error",
          templateUrl: 'templates/modals/success_or_error.html',
          scope: $scope
        });

        alertPopup.then(function(res) {
          $scope.freezeButton = undefined;
          // this doesn't actually do anything
          $state.go($state.current, {}, {reload: true});
        });
      } else {
        $scope.message = 'Bid for Instant Climb Created'

        var alertPopup = $ionicPopup.alert({
          title: "",
          templateUrl: 'templates/modals/success_or_error.html',
          scope: $scope
        });

        alertPopup.then(function(res) {
          $scope.freezeButton = undefined;
          $state.go('app.instantClimbs');
        });
      }
    })
  }
})

.controller('InstantClimbsCreateCtrl', function($scope, $state, $stateParams, $ionicPopup, $ionicLoading, InstantClimbService) {

  $scope.newInstantClimb = function(startDate, endDate, pickup_address, available_spots, languages_spoken, climbing_type, experience_level, notes) {
    $scope.freezeButton = true;
    $scope.loading = $ionicLoading.show({
      content: 'Loading...',
      showBackdrop: true
    });
    InstantClimbService.create(startDate, endDate, pickup_address, available_spots, languages_spoken, climbing_type, experience_level, notes, function(data) {
      $ionicLoading.hide();

      if (data.errors) {
        $scope.message = data.errors;

        var alertPopup = $ionicPopup.alert({
          title: "Error",
          templateUrl: 'templates/modals/success_or_error.html',
          scope: $scope
        });

        alertPopup.then(function(res) {
          $scope.freezeButton = undefined;
          // this doesn't actually do anything
          $state.go($state.current, {}, {reload: true});
        });
      } else {
        $scope.message = 'Climbers will now be able to bid on climbs, please be patient in the meantime'

        var alertPopup = $ionicPopup.alert({
          title: "Instant Climb Created",
          templateUrl: 'templates/modals/success_or_error.html',
          scope: $scope
        });

        alertPopup.then(function(res) {
          $scope.freezeButton = undefined;
          $state.go('app.instantClimbs');
        });
      }
    })
  }
})

.controller('InstantClimbConfirmationCtrl', function($scope, $state, $stateParams, $ionicPopup, $ionicLoading, InstantClimbService,
                                                    InstantClimbBidService, $ionicSlideBoxDelegate, $ionicModal, $ionicPopup, StripeCharge) {
  $scope.loading = $ionicLoading.show({
    content: 'Loading...',
    showBackdrop: false
  });

  InstantClimbBidService.viewSelectedBid($stateParams.instantClimbId, $stateParams.bidId, function(data) {
    $scope.instantClimb = data[0];
    $scope.bid = data[1];
    // $scope.user_images = data
    $ionicLoading.hide();
    $ionicSlideBoxDelegate.update();
  })

  $scope.goBack = function() {
    $state.go('app.userTrips');
  }

  // payment stuff
  // init "ProductMeta" as empty obj
  $scope.ProductMeta = {};

  $scope.charge = function() {
    // "ProductMeta" built w/ instant climb as $scope.instantClimb instead of charge(trip)
    $scope.ProductMeta.title = 'Instant Climb to ' + $scope.instantClimb.pickup_address;
    $scope.ProductMeta.description = $scope.instantClimb.notes;
    $scope.ProductMeta.priceUSD = $scope.bid.price;
    $scope.ProductMeta.image = $scope.bid.bidder_img;

    StripeCharge.getStripeToken($scope.ProductMeta).then(
      function(data){
        proceedCharge(data);
      },
      function(error){
        console.log(error);
      }
    );

    function proceedCharge(data) {
      // StripeCharge.chargeUser(stripeToken, $scope.ProductMeta).then(
      //   function (StripeInvoiceData) {
          // run script to update trip, make trip_conf, etc here
          // on success of those service calls, then render this popup
          return InstantClimbBidService.bookInstantClimb($scope.instantClimb.id, $scope.bid.id,
                                    data.stripeToken, data.stripeEmail, function(data) {
            $scope.message = data.join("");
            var alertPopup = $ionicPopup.alert({
              title: 'Instant Climb',
              templateUrl: 'templates/modals/success_or_error.html',
              scope: $scope
            });

            alertPopup.then(function(res) {
              $state.go('app.instantClimbs');
            });
          })
        // },
        // function (error) {
        //   $scope.message = "Oops... something went wrong: \n" + error;
        //   var alertPopup = $ionicPopup.alert({
        //     title: 'Trip Feed',
        //     templateUrl: 'templates/modals/success_or_error.html',
        //     scope: $scope
        //   });

        //   alertPopup.then(function(res) {
        //     $state.go($state.current, {}, {reload: true});
        //   });
        // }
      // );
    };
  };
})

/* end controllers */
