angular.module('climblife').directive('tripMap', ['$compile', function($compile) {
  return {
    restrict: 'E',
    replace: true,
    template: '<div class="trip-map"></div>',
    scope: {
      center: '=?',
      zoom: '=?',
      markers: '=?',
      goTrip: '&',
    },
    link: function(scope, element, attributes) {
      if (scope.markers && !scope.center) {
        var GLOBE_WIDTH = 256,
          minLat, maxLat,
          minLng, maxLng,
          sumLat = 0, sumLng = 0,
          centerLat, centerLng;

        for (var i = 0; i < scope.markers.length; i++) {
          var marker = scope.markers[i];
          if (minLat === undefined || minLat > marker.lat) minLat = marker.lat;
          if (maxLat === undefined || maxLat < marker.lat) minLat = marker.lat;
          if (minLng === undefined || minLng > marker.lng) minLng = marker.lng;
          if (maxLng === undefined || maxLng < marker.lng) maxLng = marker.lng;
          sumLat+= marker.lat;
          sumLng+= marker.lng;
        }
        centerLat = sumLat / scope.markers.length;
        centerLng = sumLng / scope.markers.length;
        scope.center = {lat: centerLat, lng: centerLng};
        var angle = maxLng - minLng;
        if (angle < 0) {angle += 360;}
        scope.zoom = Math.round(Math.log(element[0].getBoundingClientRect().width * 360 / angle / GLOBE_WIDTH) / Math.LN2);

        console.log(scope.center, scope.zoom);
      } else if (scope.center) {

      }
      var map = new google.maps.Map(element[0], {
        zoom: scope.zoom,
        center: scope.center
      });
      var infowindow =  new google.maps.InfoWindow({
          content: ""
      });

      var bindInfoWindow = function(marker, map, infowindow, infoSelector, markerData) {
        marker.addListener('click', function() {
          var dialog = angular.element(document.getElementById(infoSelector).outerHTML);
          // var dialog = (document.getElementById(infoSelector).outerHTML);
          scope.marker = markerData;
          console.log(markerData);
          $compile(dialog)(scope);
          console.log(dialog);
          infowindow.setContent(dialog[0]);
          infowindow.open(map, this);
        });
      }
      var icon = 'img/climblife-logo.svg';

      var markers = [];
      if (scope.markers && Array.isArray(scope.markers)) for (var i = 0; i < scope.markers.length; i++) {
        var markerData = scope.markers[i];

        var marker = new google.maps.Marker({
          map: map,
          draggable: false,
          animation: google.maps.Animation.DROP,
          position: new google.maps.LatLng(markerData.lat, markerData.lng),
          label: {
            text: markerData.label,
            fontWeight: 'bold',
            color: '#ff771d'
          },
          icon: {
            url: icon,
            size: new google.maps.Size(45, 45),
            origin: new google.maps.Point(0, 0),
            anchor: new google.maps.Point(0, 20),
            scaledSize: new google.maps.Size(40, 40),
            labelOrigin: new google.maps.Point(20, 50)
          }
        });

        if (markerData.info) {
          bindInfoWindow(marker, map, infowindow, markerData.info, markerData);
        }

        markers.push(marker);
        // console.log(marker);
      }
      var markerCluster = new MarkerClusterer(map, markers,
            {imagePath: 'img/climblife-logo', zoomOnClick: true});
      // element

      scope.clickTrip = function(tripId) {
        console.log(tripId);
        scope.goTrip({tripId: tripId});
      }
    }
  }
}]);
